<?php
//ob_start();
//setcookie( "name", "value", 100 );
/**
 * Metabox arrays for retrieving
 * Custom values
 */
$key ='andrina-lite';
$meta_boxes = array(
	'video_url' => array(
		'name' => 'video_url',
		'type' => 'textarea',
		'title' => __( 'Embed Video, Quotes', 'andrina-lite' ),
		'description' => __( 'Enter the video Embed or quotes according to post format selected', 'andrina-lite' ),
		'id' => 'video_url'
	),
);

$image_meta = array(
	'Image1' => array(
		'name' => '_meta_audio',
		'title' => __( 'Upload Your Own Audio of mp3', 'andrina-lite' ),
		'description' => __( 'Upload Your Own Audio of mp3', 'andrina-lite' ),
		'id' =>'andrina-lite' . '_meta_image1',
		'upload_id' =>'andrina-lite' . '_meta_upload_image_button1',
		'type' => 'upload'
	)
);

/**
 * Function for create meta box
 * @global string $key 
 */
function andrina_create_meta_box() {
	global $key;
	if ( function_exists( 'add_meta_box' ) )
		add_meta_box( 'meta-boxes', __( 'Enter Video Embed Code or Quotes', 'andrina-lite' ), 'andrina_meta_box', 'post', 'normal', 'high' );
	add_meta_box( 'image-meta-boxes', __( 'Upload Your Own Audio', 'andrina-lite' ), 'andrina_image_meta', 'post', 'normal', 'high' );
}

/**
 * Function for creating UI Meta box
 * @global type $post
 * @global array $meta_boxes
 * @global string $key 
 */
function andrina_meta_box() {
	global $post, $meta_boxes, $key;
	?>
	<div class="panel-wrap">	
		<div class="form-wrap">
			<?php
			wp_nonce_field( plugin_basename( __FILE__ ), $key . '_wpnonce', false, true );
			foreach ( $meta_boxes as $meta_box ) {
				$data = get_post_meta( $post->ID, $meta_box['name'], true );
				?>
				<div class="form-field form-required" style="margin:0; padding: 0 8px">
					<?php
					if ( $meta_box['type'] == 'geo_map_input' ) {
						
					} else {
						?>
						<label for="<?php echo $meta_box['name']; ?>" style="color: #666; padding-bottom: 8px; overflow:hidden; zoom:1; "><?php echo $meta_box['title']; ?></label>
					<?php } ?>
					<?php
					if ( !isset( $meta_box['type'] ) )
						$meta_box['type'] = 'input';
					switch ( $meta_box['type'] ) :
						case "datetime" :
							if ( $post->post_status <> 'publish' ) :
								echo '<p>' . __( 'Post is not yet published', 'andrina-lite' ) . '</p>';
							else :
								$date = $data;
								if ( !$data ) {
									// Date is 30 days after publish date (this is for backwards compatibility)
									$date = strtotime( '+30 day', strtotime( $post->post_date ) );
								}
								?>							
								<div style="float:left; margin-right: 10px; min-width: 320px;"><select name="<?php echo $meta_box['name']; ?>_month">
										<?php
										for ( $i = 1; $i <= 12; $i++ ) :
											echo '<option value="' . str_pad( $i, 2, '0', STR_PAD_LEFT ) . '" ';
											if ( date_i18n( 'F', $date ) == date_i18n( 'F', strtotime( '+' . $i . ' month', mktime( 0, 0, 0, 12, 1, 2010 ) ) ) )
												echo 'selected="selected"';
											echo '>' . date_i18n( 'F', strtotime( '+' . $i . ' month', mktime( 0, 0, 0, 12, 1, 2010 ) ) ) . '</option>';
										endfor;
										?>
									</select>
									<select name="<?php echo $meta_box['name']; ?>_day">
										<?php
										for ( $i = 1; $i <= 31; $i++ ) :
											echo '<option value="' . str_pad( $i, 2, '0', STR_PAD_LEFT ) . '" ';
											if ( date_i18n( 'd', $date ) == str_pad( $i, 2, '0', STR_PAD_LEFT ) )
												echo 'selected="selected"';
											echo '>' . str_pad( $i, 2, '0', STR_PAD_LEFT ) . '</option>';
										endfor;
										?>
									</select>
									<select name="<?php echo $meta_box['name']; ?>_year">
										<?php
										for ( $i = 2010; $i <= 2020; $i++ ) :
											echo '<option value="' . $i . '" ';
											if ( date_i18n( 'Y', $date ) == $i )
												echo 'selected="selected"';
											echo '>' . $i . '</option>';
										endfor;
										?>
									</select>@<input type="text" name="<?php echo $meta_box['name']; ?>_hour" size="2" maxlength="2" style="width:2.5em" value="<?php echo date_i18n( 'H', $date ) ?>" />:<input type="text" name="<?php echo $meta_box['name']; ?>_min" size="2" maxlength="2" style="width:2.5em" value="<?php echo date_i18n( 'i', $date ) ?>" /></div><?php
								if ( $meta_box['description'] )
									echo wpautop( wptexturize( $meta_box['description'] ) );
								?>
							<?php
							endif;
							break;
						default :
							?>
							<input id="<?php echo $meta_box['id']; ?>" type="text" style="width:320px; margin-right: 10px; float:left" name="<?php echo $meta_box['name']; ?>" value="<?php echo $data; ?>" /><?php
							if ( $meta_box['description'] )
								echo wpautop( wptexturize( $meta_box['description'] ) );
							?>
							<?php
							break;
					endswitch;
					?>				
					<div class="clear"></div>
				</div>
			<?php } ?>
		</div>
	</div>	
	<?php
}

/**
 * Function for creating image
 * Meta boxes
 * @global type $post
 * @global array $image_meta
 * @global string $key 
 * 
 */
function andrina_image_meta() {
	global $post, $image_meta, $key;
	?>
	<script type="text/javascript" src="<?php echo ANDRINA_DIR_URI . 'includes/inkoption-framework/js/ajaxupload.js'; ?>"></script>
	<!--<script type="text/javascript" src="<?php echo get_template_directory_uri(); ?>/functions/js/colorpicker.js"></script>-->
	<!--<script type="text/javascript" src="<?php echo get_template_directory_uri(); ?>/functions/js/jquery.maskedinput-1.2.2.js"></script>-->
	<div class="panel-wrap">	
		<div class="form-wrap">
			<script type="text/javascript">
				// -- NO CONFLICT MODE --
				var $ = jQuery.noConflict();
				$(function () {
					//AJAX Upload
					jQuery('.image_upload_button').each(function () {
						var clickedObject = jQuery(this);
						var clickedID = jQuery(this).attr('id');
						new AjaxUpload(clickedID, {
							action: '<?php echo admin_url( "admin-ajax.php" ); ?>',
							name: clickedID, // File upload name
							data: {// Additional data to send
								action: 'of_ajax_video_post_action',
								type: 'upload',
								data: clickedID,
								option_nonce: $('#<?php echo $key . '_wpnonce'; ?>').val()
							},
							autoSubmit: true, // Submit file after selection
							responseType: false,
							onChange: function (file, extension) {
							},
							onSubmit: function (file, extension) {
								clickedObject.text('Uploading'); // change button text, when user selects file	
								this.disable(); // If you want to allow uploading only 1 file at time, you can disable upload button
								interval = window.setInterval(function () {
									var text = clickedObject.text();
									if (text.length < 13) {
										clickedObject.text(text + '.');
									} else {
										clickedObject.text('Uploading');
									}
								}, 200);
							},
							onComplete: function (file, response) {
								var data = JSON.parse(response);
								window.clearInterval(interval);
								clickedObject.text('Upload');
								this.enable(); // enable upload button

								// If there was an error
								if (data.error) {
									var buildReturn = '<span class="upload-error">' + data.error + '</span>';
									jQuery(".upload-error").remove();
									clickedObject.parent().after(buildReturn);
								} else {
									var buildReturn = '<iframe width="560" height="315" style="margin-top: 10px;" class="hide meta-image" id="image_' + clickedID + '" src="' + data.url + '" frameborder="0" allowfullscreen></iframe>';
									jQuery(".upload-error").remove();
									jQuery("#image_" + clickedID).remove();
									clickedObject.parent().after(buildReturn);
									jQuery('img#image_' + clickedID).fadeIn();
									clickedObject.next('span').fadeIn();
									clickedObject.parent().prev('input').val(data.url);
								}
							}
						});

					});
					//AJAX Remove (clear option value)
					jQuery('.image_reset_button').click(function () {

						var clickedObject = jQuery(this);
						var clickedID = jQuery(this).attr('id');
						var theID = jQuery(this).attr('title');

						var ajax_url = '<?php echo admin_url( "admin-ajax.php" ); ?>';

						var data = {
							action: 'of_ajax_video_post_action',
							type: 'image_reset',
							data: theID
						};

						jQuery.post(ajax_url, data, function (response) {
							var image_to_remove = jQuery('#image_' + theID);
							var button_to_hide = jQuery('#reset_' + theID);
							image_to_remove.fadeOut(500, function () {
								jQuery(this).remove();
							});
							button_to_hide.fadeOut();
							clickedObject.parent().prev('input').val('');
						});
						return false;
					});
				});
			</script>
			<?php
			wp_nonce_field( plugin_basename( __FILE__ ), $key . '_wpnonce', false, true );
			foreach ( $image_meta as $image_box ) {
				$data = get_post_meta( $post->ID, $image_box['name'], true );
				?>
				<div class="form-field form-required" style="margin:0; padding: 0 8px">
					<label for="<?php echo $image_box['name']; ?>" style="color: #666; padding-bottom: 8px; overflow:hidden; zoom:1; "><?php echo $image_box['title']; ?></label>
					<?php
					if ( !isset( $image_box['type'] ) )
						$image_box['type'] = 'input';
					switch ( $image_box['type'] ) :
						case "upload":
							?>                            
							<input class='of-input' style="width:500px; margin-bottom: 10px;" name='<?php echo $image_box['name']; ?>' id='<?php echo $image_box['name']; ?>_upload' type='text' value='<?php echo htmlspecialchars( $data ); ?>' />
							<div class="upload_button_div"><span class="button image_upload_button" id="<?php echo $image_box['name']; ?>">Upload</span>
								<?php $hide = ($data != '') ? '' : 'hide'; ?>                               
								<span class="button image_reset_button <?php echo $hide; ?>" id="reset_<?php echo $image_box['name']; ?>" title="<?php echo $image_box['name']; ?>">Remove</span>
							</div>								
							<?php if ( $data != '' ) { ?>							
								<iframe width="560" height="315" id="<?php echo $image_box['name']; ?>" src="<?php echo $data; ?>" style="margin-top: 10px;" frameborder="0" allowfullscreen></iframe>
								<?php
							}
							break;
						default :
							?>
							<input type="text" style="width:320px; margin-right: 10px; float:left" name="<?php echo $image_box['name']; ?>" value="<?php echo htmlspecialchars( $data ); ?>" /><?php
							if ( $image_box['description'] )
								echo wpautop( wptexturize( $image_box['description'] ) );
							?>
							<?php
							break;
					endswitch;
					?>				
					<div class="clear"></div>
				</div>
			<?php } ?>
		</div>
	</div>
	<?php
}

/**
 * @global type $post
 * @global array $meta_boxes
 * @global string $key
 * @param type $post_id
 * @return type 
 */
function andrina_save_meta_box( $post_id ) {
	global $post, $meta_boxes, $key, $image_meta, $checkbox_meta;
	if ( !isset( $_POST[$key . '_wpnonce'] ) )
		return $post_id;
	if ( !wp_verify_nonce( $_POST[$key . '_wpnonce'], plugin_basename( __FILE__ ) ) )
		return $post_id;
	if ( !current_user_can( 'edit_post', $post_id ) )
		return $post_id;
	foreach ( $image_meta as $image_box ) {
		update_post_meta( $post_id, $image_box['name'], $_POST[$image_box['name']] );
	}
	foreach ( $meta_boxes as $meta_box ) {
		if ( $meta_box['type'] == 'datetime' ) {
			$year = $_POST[$meta_box['name'] . '_year'];
			$month = $_POST[$meta_box['name'] . '_month'];
			$day = $_POST[$meta_box['name'] . '_day'];
			$hour = $_POST[$meta_box['name'] . '_hour'];
			$min = $_POST[$meta_box['name'] . '_min'];
			if ( !$hour )
				$hour = '00';
			if ( !$min )
				$min = '00';
			if ( checkdate( $month, $day, $year ) ) :
				$date = $year . $month . $day . ' ' . $hour . ':' . $min;
				update_post_meta( $post_id, $meta_box['name'], strtotime( $date ) );
			endif;
		} else {
			update_post_meta( $post_id, $meta_box['name'], $_POST[$meta_box['name']] );
		}
	}
}

/**
 * function to add image or video in meteboxs
 */
function inkthemes_ajax_video_callback() {
	wp_verify_nonce( 'andrina-lite_wpoption', 'option_nonce' );
	$save_type = $_POST['type'];
	$file_types = array( 'audio/mpeg', 'audio/mpeg3', 'audio/x-mpeg-3', 'audio/x-mpeg', 'audio/aac', 'audio/m4a' );
	//Uploads
	if ( $save_type == 'upload' ) {

		$clickedID = $_POST['data']; // Acts as the name
		$filename = $_FILES[$clickedID];
		$filename['name'] = preg_replace( '/[^a-zA-Z0-9._\-]/', '', $filename['name'] );

		$override['test_form'] = false;
		$override['action'] = 'wp_handle_upload';
		$uploaded_file = wp_handle_upload( $filename, $override );
		$response = array();
		if ( isset( $uploaded_file ) && in_array( $uploaded_file['type'], $file_types ) ) {
			$upload_tracking[] = $clickedID;
			andrina_update_option( $clickedID, $uploaded_file['url'] );
			if ( !empty( $uploaded_file['error'] ) ) {
				$response['error'] = __( 'Upload Error: ', 'andrina-lite' ) . $uploaded_file['error'];
			} else {
				$response['url'] = $uploaded_file['url'];
			}
		} else {
			$response['error'] = __( 'Unsupported filetype uploaded.', 'andrina-lite' );
		} // Is the Response
		echo json_encode( $response );
		die();
	} elseif ( $save_type == 'image_reset' ) {
		$id = $_POST['data']; // Acts as the name
		andrina_delete_option( $id );
	}
}

add_action( 'wp_ajax_of_ajax_video_post_action', 'inkthemes_ajax_video_callback' );
add_action( 'admin_menu', 'andrina_create_meta_box' );
add_action( 'save_post', 'andrina_save_meta_box' );
?>